DefaultArrayAdapter (FreeMarker 2.3.35 API)
Description: declaration: package: freemarker.template, class: DefaultArrayAdapter

Package freemarker.template

# Class DefaultArrayAdapter

java.lang.Object
freemarker.template.WrappingTemplateModel
freemarker.template.DefaultArrayAdapter

All Implemented Interfaces:
  `WrapperTemplateModel`, `AdapterTemplateModel`, `TemplateModel`, `TemplateSequenceModel`, `Serializable`

public abstract class DefaultArrayAdapter extends WrappingTemplateModel implements TemplateSequenceModel, AdapterTemplateModel, WrapperTemplateModel, Serializable
Adapts an `array` of a non-primitive elements to the corresponding `TemplateModel` interface(s), most importantly to `TemplateHashModelEx`. If you aren't wrapping an already existing `array`, but build a sequence specifically to be used from a template, also consider using `SimpleSequence` (see comparison there).

Thread safety: A `DefaultListAdapter` is as thread-safe as the array that it wraps is. Normally you only have to consider read-only access, as the FreeMarker template language doesn't allow writing these sequences (though of course, Java methods called from the template can violate this rule).

This adapter is used by `DefaultObjectWrapper` if its `useAdaptersForCollections` property is `true`, which is the default when its `incompatibleImprovements` property is 2.3.22 or higher.

Since:
  2.3.22
See Also:
  `SimpleSequence`, `DefaultListAdapter`, `TemplateSequenceModel`, Serialized Form

- ## Field Summary

  ### Fields inherited from interface freemarker.template.TemplateModel

  `NOTHING`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultArrayAdapter`
  `adapt​(Object array, ObjectWrapperAndUnwrapper wrapper)`
  Factory method for creating new adapter instances.
  `Object`
  `getAdaptedObject​(Class hint)`
  Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.

  ### Methods inherited from class freemarker.template.WrappingTemplateModel

  `getDefaultObjectWrapper, getObjectWrapper, setDefaultObjectWrapper, setObjectWrapper, wrap`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface freemarker.template.TemplateSequenceModel

  `get, size`

  ### Methods inherited from interface freemarker.ext.util.WrapperTemplateModel

  `getWrappedObject`

- ## Method Details

  - ### adapt

    public static DefaultArrayAdapter adapt​(Object array, ObjectWrapperAndUnwrapper wrapper)
    Factory method for creating new adapter instances.
    Parameters:
      `array` - The array to adapt; can't be `null`. Must be an array.
      `wrapper` - The `ObjectWrapper` used to wrap the items in the array. Has to be `ObjectWrapperAndUnwrapper` because of planned future features.

  - ### getAdaptedObject

    public final Object getAdaptedObject​(Class hint)
    Description copied from interface: `AdapterTemplateModel`
    Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.
    Specified by:
      `getAdaptedObject` in interface `AdapterTemplateModel`
    Parameters:
      `hint` - the desired class of the returned value. An implementation should make reasonable effort to retrieve an object of the requested class, but if that is impossible, it must at least return the underlying object as-is. As a minimal requirement, an implementation must always return the exact underlying object when `hint.isInstance(underlyingObject)` holds. When called with `java.lang.Object.class`, it should return a generic Java object (i.e. if the model is wrapping a scripting language object that is further wrapping a Java object, the deepest underlying Java object should be returned).
    Returns:
      the underlying object, or its value accommodated for the hint class.